using UnityEngine;
using System.Collections;

public class EyeController : MonoBehaviour 
{
	private Transform eyeBall;
	private Transform upperLid;
	private Transform lowerLid;
	private ParticleSystem hitBurst;
	
	private float upperLidMax = 40.0f;
	private float upperLidMin = 0.0f;
	
	private float lowerLidMax = 30.0f;
	private float lowerLidMin = 0.0f;
	
	private float openDelay = 4.0f;
	private float openTimer = 0.0f;
	
	private float eyeSinOffset;
	private float eyeSinScale;
	
	private PlayerController playerC;
	private Manager manager;
	private bool followEye = false;
	
	public float sinInfo = 0.0f;
	private Color originalEyeColor;
	private int eyeColorResetFrames = 0;
	
	private float health;
	private bool dead = false;
	
	// start some shit
	void Start () 
	{
		playerC = GameObject.Find("Player").GetComponent<PlayerController>();
		manager = GameObject.Find("_MANAGER").GetComponent<Manager>();
		
		if(Random.Range(0.0f, 1.0f) > 0.5f) 
			followEye = true; 
		
		eyeBall = transform.FindChild("Eye");
		upperLid = transform.FindChild("UpperLid");
		lowerLid = transform.FindChild("LowerLid");
		hitBurst = transform.FindChild("HitBurst").GetComponent<ParticleSystem>();
		
		originalEyeColor = eyeBall.renderer.material.color;
		eyeSinOffset = Random.Range(0.0f, 100.0f);
		eyeSinScale = Random.Range(0.3333f, 3.3333f);
		
		health = Random.Range(0.3333f, 2.3333f);
	}
	
	// Update is called once per frame
	void Update () 
	{
		if(eyeColorResetFrames <= 0)
			eyeBall.renderer.material.color = originalEyeColor;
		else
			eyeColorResetFrames -= 1;
		
		sinInfo = Mathf.Sin((Time.time+eyeSinOffset)*eyeSinScale);
			
		transform.LookAt(playerC.transform.position);
		
		if(dead == false)
		{
			upperLid.rotation = Quaternion.identity;
			upperLid.Rotate(new Vector3(0.0f, 0.0f, (Mathf.Sin((Time.time+eyeSinOffset)*eyeSinScale)*upperLidMax)+20.0f));
			
			lowerLid.rotation = Quaternion.identity;
			lowerLid.Rotate(new Vector3(0.0f, 0.0f, (Mathf.Sin((Time.time+eyeSinOffset)*eyeSinScale)*-upperLidMax)+120.0f));
		}
		else
		{
			if(Random.Range(0.0f, 1.0f) > 0.98f)
				hitBurst.Emit(1);	
		}
		
		
		if(health <= 0.0f && dead == false)
		{
			// shut your eye for good sweet prince
			upperLid.rotation = Quaternion.identity;
			lowerLid.rotation = Quaternion.identity;
			lowerLid.Rotate(new Vector3(0.0f, 0.0f, 180.0f));
			manager.PlayEyeDeath();
			dead = true;
		}
		
	}
	
	void OnTriggerStay(Collider other)
	{
		if(other.gameObject.tag == "PlayerWeapon" && sinInfo > -0.4f && health > 0.0f)
		{
			eyeBall.renderer.material.color = new Color(Random.Range(0.0f, 1.0f), Random.Range(0.0f, 1.0f), Random.Range(0.0f, 1.0f), 1.0f);
			iTween.ShakePosition(gameObject, new Vector3(50.0f, 50.0f, 50.0f), 0.2f);	
			eyeColorResetFrames = 10;
			hitBurst.Emit(3);
			health -= Time.deltaTime;
			manager.totalMonsterDamage += Time.deltaTime;
		}
	}
}
