using UnityEngine;
using System.Collections;

public class Manager : MonoBehaviour 
{
	public bool startFade = false;
	public bool fadeOver = false;
	public GameObject cthulu;
	private PlayerController playerC;
	
	public Texture2D citizen;
	public Texture2D pueblo;
	public Font UIFont;
	
	public float totalMonsterDamage = 0.0f;
	
	public int pueblosRemaining;
	public int citizensRemaining;
	
	public AudioSource SFX_CitizenDeath;
	public AudioSource SFX_PuebloDeath;
	public AudioSource SFX_EyeDeath;
	public AudioClip lose;
	public AudioClip monsterHello;
	
	public bool gameLost = false;
	public bool gameWon = false;
	
	// Use this for initialization
	void Start () 
	{
		playerC = GameObject.Find("Player").GetComponent<PlayerController>();
		
		SFX_CitizenDeath = transform.FindChild("SFX_CitizenDeath").GetComponent<AudioSource>();
		SFX_PuebloDeath = transform.FindChild("SFX_PuebloDeath").GetComponent<AudioSource>();
		SFX_EyeDeath = transform.FindChild("SFX_EyeDeath").GetComponent<AudioSource>();
		CountUnits();
	}
	
	public void CountUnits()
	{
		pueblosRemaining = 0;
		citizensRemaining = 0;
		
		foreach (GameObject pueblo in GameObject.FindGameObjectsWithTag("Pueblo"))
		{
			pueblosRemaining += 1;
		}		
		
		foreach (GameObject citizen in GameObject.FindGameObjectsWithTag("Citizen"))
		{
			citizensRemaining += 1;
		}			
		
		//print (pueblosRemaining +" PUEBLOS REMAIN");
		//print (citizensRemaining +" CITIZENS REMAIN");
	}
	
	
	// Update is called once per frame
	void FixedUpdate () 
	{
		if(startFade == true && fadeOver == false)
		{
			float h = 0.0f;
			float s = 0.0f;
			float v = 0.0f;
			ColorToHSV(Camera.mainCamera.backgroundColor, out h, out s, out v);
			h += Time.deltaTime * 20.0f;
			if(h > 360.0f)
			{
				h = 359.0f;
				fadeOver = true;
				
				foreach (GameObject citizen in GameObject.FindGameObjectsWithTag("Citizen"))
				{
					citizen.audio.Play();
				}						
			}
			Camera.mainCamera.backgroundColor = ColorFromHSV(h, s, v);
		}
		
		if(gameWon == true)
		{
			RenderSettings.fog = true;
			
			float h = 0.0f;
			float s = 0.0f;
			float v = 0.0f;
			RenderSettings.ambientLight = new Color(0.666f, 0.0f, 0.0f, 1.0f);
			ColorToHSV(RenderSettings.ambientLight, out h, out s, out v);
			h = Time.time * 6.0f;
			RenderSettings.ambientLight = ColorFromHSV(h, s, v);	
			
			h = 0.0f;
			s = 0.0f;
			v = 0.0f;
			RenderSettings.fogColor = new Color(0.0f, 0.6f, 0.7f, 1.0f);
			ColorToHSV(RenderSettings.fogColor, out h, out s, out v);
			h = Time.time * 8.0f;
			RenderSettings.fogColor = ColorFromHSV(h, s, v);		
		}
	}
	
	void OnGUI()
	{
		float widthScale = ((float)Screen.width / 1280.0f);	
		
		if(fadeOver == true)
		{
			GUI.DrawTexture(screenRect(0.04f, 0.775f, 0.05f, 0.1f), citizen);
			GUI.DrawTexture(screenRect(0.01f, 0.875f, 0.08f, 0.1f), pueblo);
		
			GUIStyle myStyle = new GUIStyle();
			myStyle.font = UIFont;
			myStyle.fontSize = (int)(widthScale * 30.0f); 	
			myStyle.normal.textColor = Color.blue;	
			
			GUI.Label(screenRect(0.1f, 0.8f, 0.05f, 0.1f), "Citizens: "+citizensRemaining, myStyle);
			GUI.Label(screenRect(0.1f, 0.9f, 0.05f, 0.1f), "Pueblos: "+pueblosRemaining, myStyle);
		}
		
		if(gameLost == true)
		{
			RenderSettings.ambientLight = new Color(0.666f, 0.0f, 0.0f, 1.0f);
			RenderSettings.fog = true;
			RenderSettings.fogColor = new Color(0.666f, 0.0f, 0.0f, 1.0f);
			
			
			GUIStyle myStyle = new GUIStyle();
			myStyle.font = UIFont;
			myStyle.fontSize = (int)(widthScale * 100.0f); 	
			myStyle.normal.textColor = Color.white;	
			
			GUIStyle myStyle2 = new GUIStyle();
			myStyle2.font = UIFont;
			myStyle2.fontSize = (int)(widthScale * 100.0f); 	
			myStyle2.normal.textColor = Color.black;	
			
			GUI.Label(screenRect(0.105f, 0.105f, 1.0f, 1.0f), "ALL DEAD..THE FUTURE\n...IS FORSAKEN?!?!", myStyle);
			GUI.Label(screenRect(0.095f, 0.095f, 1.0f, 1.0f), "ALL DEAD..THE FUTURE\n...IS FORSAKEN?!?!", myStyle);
			GUI.Label(screenRect(0.1f, 0.1f, 1.0f, 1.0f), "ALL DEAD..THE FUTURE\n...IS FORSAKEN?!?!", myStyle2);
			
			GUI.Label(screenRect(0.035f, 0.795f, 1.0f, 1.0f), "YA BLEW IT, CAPICHE?", myStyle);	
			GUI.Label(screenRect(0.045f, 0.805f, 1.0f, 1.0f), "YA BLEW IT, CAPICHE?", myStyle);	
			GUI.Label(screenRect(0.04f, 0.8f, 1.0f, 1.0f), "YA BLEW IT, CAPICHE?", myStyle2);				
		}
		
		if(gameWon == true)
		{
			GUIStyle myStyle = new GUIStyle();
			myStyle.font = UIFont;
			myStyle.fontSize = (int)(widthScale * 110.0f); 	
			myStyle.normal.textColor = Color.white;	
			
			GUIStyle myStyle2 = new GUIStyle();
			myStyle2.font = UIFont;
			myStyle2.fontSize = (int)(widthScale * 110.0f); 	
			myStyle2.normal.textColor = Color.black;	
			
			GUI.Label(screenRect(0.025f, 0.105f, 1.0f, 1.0f), "-[ MENACE MANAGED ]-", myStyle);
			GUI.Label(screenRect(0.035f, 0.095f, 1.0f, 1.0f), "-[ MENACE MANAGED ]-", myStyle);
			GUI.Label(screenRect(0.03f, 0.1f, 1.0f, 1.0f), "-[ MENACE MANAGED ]-", myStyle2);
			
			GUI.Label(screenRect(0.085f, 0.395f, 1.0f, 1.0f), "You gotta be a \nbad dude with a \nrude 'tude!", myStyle);	
			GUI.Label(screenRect(0.095f, 0.405f, 1.0f, 1.0f), "You gotta be a \nbad dude with a \nrude 'tude!", myStyle);	
			GUI.Label(screenRect(0.09f, 0.4f, 1.0f, 1.0f), "You gotta be a \nbad dude with a \nrude 'tude!", myStyle2);		
		}
	}
	
	void Update()
	{
		if(totalMonsterDamage > 40.0f)
		{
			gameWon = true;
			playerC.rigidbody.useGravity = false;
			playerC.rigidbody.detectCollisions = false;
			playerC.rigidbody.drag = 600.0f;
			
			foreach (GameObject obj in GameObject.FindGameObjectsWithTag("Eye"))
			{
				Destroy (obj);
			}				
			
			foreach (GameObject obj in GameObject.FindGameObjectsWithTag("Tentacle"))
			{
				Destroy (obj);
			}		
		}
		
		if(pueblosRemaining < 1 && citizensRemaining < 6)
		{
			playerC.rigidbody.useGravity = false;
			playerC.rigidbody.detectCollisions = false;
			playerC.rigidbody.drag = 600.0f;
			gameLost = true;
			audio.Play();
		}
		
		if(Input.GetKeyDown(KeyCode.Escape) == true)
		{
			Application.Quit();
		}	
	}
	
	public void DiscoveredReason()
	{
		//print ("DISCOVERED REASON");
		startFade = true;
		playerC.DiscoveredReason();
		cthulu.SetActive(true);
		audio.Play();
	}
	
	public void PlayCitizenDeath()
	{
		SFX_CitizenDeath.pitch = Random.Range(0.95f, 1.05f);
		SFX_CitizenDeath.Play();	
	}
	
	public void PlayPuebloDeath()
	{
		SFX_PuebloDeath.pitch = Random.Range(0.95f, 1.05f);
		SFX_PuebloDeath.Play();	
	}
	
	public void PlayEyeDeath()
	{
		SFX_EyeDeath.pitch = Random.Range(0.7f, 1.5f);
		SFX_EyeDeath.Play();	
	}
	
	

    public Color ColorFromHSV(float h, float s, float v, float a = 1)
    {
            // no saturation, we can return the value across the board (grayscale)
            if (s == 0)
                return new Color(v, v, v, a);
     
            // which chunk of the rainbow are we in?
            float sector = h / 60;
     
            // split across the decimal (ie 3.87 into 3 and 0.87)
            int i = (int)sector;
            float f = sector - i;
     
            float p = v * (1 - s);
            float q = v * (1 - s * f);
            float t = v * (1 - s * (1 - f));
     
            // build our rgb color
            Color color = new Color(0, 0, 0, a);
     
            switch(i)
            {
                case 0:
                    color.r = v;
                    color.g = t;
                    color.b = p;
                    break;
     
                case 1:
                    color.r = q;
                    color.g = v;
                    color.b = p;
                    break;
     
                case 2:
                    color.r  = p;
                    color.g  = v;
                    color.b  = t;
                    break;
     
                case 3:
                    color.r  = p;
                    color.g  = q;
                    color.b  = v;
                    break;
     
                case 4:
                    color.r  = t;
                    color.g  = p;
                    color.b  = v;
                    break;
     
                default:
                    color.r  = v;
                    color.g  = p;
                    color.b  = q;
                    break;
            }
     
            return color;
    }
           
    public void ColorToHSV(Color color, out float h, out float s, out float v)
    {
            float min = Mathf.Min(Mathf.Min(color.r, color.g), color.b);
            float max = Mathf.Max(Mathf.Max(color.r, color.g), color.b);
            float delta = max - min;
     
            // value is our max color
            v = max;
     
            // saturation is percent of max
            if (!Mathf.Approximately(max, 0))
                s = delta / max;
            else
                    {
                // all colors are zero, no saturation and hue is undefined
                s = 0;
                h = -1;
                return;
            }
     
            // grayscale image if min and max are the same
            if (Mathf.Approximately(min, max))
            {
                v = max;
                s = 0;
                h = -1;
                return;
            }
     
            // hue depends which color is max (this creates a rainbow effect)
            if (color.r == max)
                h = (color.g - color.b) / delta;            // between yellow & magenta
            else if (color.g == max)
                h = 2 + (color.b - color.r) / delta;                // between cyan & yellow
            else
                h = 4 + (color.r - color.g) / delta;                // between magenta & cyan
     
            // turn hue into 0-360 degrees
            h *= 60;
            if (h < 0 )
                h += 360;
    }

    public Rect screenRect(float tx, float ty, float tw, float th) 
    {
        float x1 = tx * Screen.width;
        float y1 = ty * Screen.height;
        float sw = tw * Screen.width;
        float sh = th * Screen.height;
        return new Rect(x1,y1,sw,sh);
    }			
	
}
