using UnityEngine;
using System.Collections;

public class PlayerController : MonoBehaviour 
{
	public float moveSpeed = 10.0f;
	public float runSpeed = 10.0f;
	public float sprintSpeed = 30.0f;
	public float pitchSensitivity = 2.0f;
	public float yawSensitivity = 4.0f;
	public float pitchUpperLimit = 120.0f;
	public float pitchLowerLimit = -65.0f;
	public Vector3 cameraPositionOffset = Vector3.zero;
	public float cameraPitch = 0.0f;
	
	public bool isFiring = false;
	private Transform theReason;
	private ParticleSystem reasonFire;
	private ParticleSystem reasonBurst;
	private Transform weaponTrigger;
	private Rotator isoRot;
	
	public bool reasonFound = false;
	public float reasonScale = 0.0f;
	private float reasonMaxScale = 0.247f;
	
	public bool disabledByReason = false;
	
	// start some shit
	void Start () 
	{
		theReason = transform.FindChild("Main Camera/iso01");
		isoRot = transform.FindChild("Main Camera/iso01").GetComponent<Rotator>();
		reasonFire = transform.FindChild("Main Camera/reasonFire").GetComponent<ParticleSystem>();
		reasonBurst = transform.FindChild("Main Camera/reasonBurst").GetComponent<ParticleSystem>();
		weaponTrigger = transform.FindChild("Main Camera/WeaponTrigger");
	}
	
	public void DiscoveredReason()
	{
		if(theReason == null)
		{
			theReason = transform.FindChild("iso01");
		}
		
		disabledByReason = true;
		theReason.renderer.enabled = true;
		theReason.localScale = new Vector3(0.01f, 0.01f, 0.01f);
		rigidbody.Sleep();
		rigidbody.useGravity = false;
	}
	
	public void DiscoveredMonster()
	{
		reasonFound = true;
		disabledByReason = false;
		rigidbody.WakeUp();
		rigidbody.useGravity = true;
	}
	
	// don't forget to Downdate()
	void Update()
	{
		// -[Jumpin]-
		if(Input.GetButtonDown("Jump") == true)	
		{
			if (Physics.Raycast(transform.position, transform.up*-1.0f, 10.0f)) 
			{
            	rigidbody.AddForce(Vector3.up * 3900.0f);			
				audio.Play();
			}
		}
	}
	
	void FixedUpdate () 
	{
		if(disabledByReason == true)
		{
			reasonScale += Time.deltaTime * 0.1f;
			theReason.localScale = new Vector3(reasonScale, reasonScale, reasonScale);
			if(reasonScale > reasonMaxScale)
			{
				disabledByReason = false;	
				DiscoveredMonster();
			}
			
			return;
		}
		
		// -[Lookin]-
		transform.Rotate(new Vector3(0.0f, Input.GetAxis("Mouse X")*yawSensitivity, 0.0f));
		
		cameraPitch -= Input.GetAxis("Mouse Y") * pitchSensitivity;
		if(cameraPitch > pitchUpperLimit)
			cameraPitch = pitchUpperLimit;
		if(cameraPitch < pitchLowerLimit)
			cameraPitch = pitchLowerLimit;
		
		Camera.mainCamera.transform.localRotation = Quaternion.identity; 
		Camera.mainCamera.transform.Rotate(new Vector3((cameraPitch), 0.0f, 0.0f));

		// -[Sprintin]-
		if(Input.GetButton("Sprint") == true)
			moveSpeed = sprintSpeed;
		else
			moveSpeed = runSpeed;
		
		// -[Glidin]-
		if(Input.GetButton("Jump") ==  true)
			rigidbody.AddForce(Vector3.up * 2400.0f * Time.deltaTime);
		
		// -[Walkin]-
		float yVel = rigidbody.velocity.y;
		rigidbody.velocity = transform.forward * Input.GetAxis("Vertical") * moveSpeed * Time.deltaTime * 60.0f;
		rigidbody.velocity += transform.right * Input.GetAxis("Horizontal") * moveSpeed * Time.deltaTime * 60.0f;
		Vector3 vel = new Vector3(rigidbody.velocity.x, yVel, rigidbody.velocity.z);
		rigidbody.velocity = vel;
		
		// too floaty
		//rigidbody.AddForce((transform.forward * Input.GetAxis("Vertical") * moveSpeed * Time.deltaTime), ForceMode.Impulse);
		//rigidbody.AddForce((transform.right * Input.GetAxis("Horizontal") * moveSpeed * Time.deltaTime), ForceMode.Impulse);
		
		// -[Shootin]-
		if(Input.GetMouseButton(0) == true && reasonFound == true)
		{
			reasonFire.Play(); 
			reasonFire.audio.pitch = Random.Range(0.5f, 1.0f);
			reasonFire.audio.Play();
			reasonBurst.Play();
			weaponTrigger.collider.enabled = true;
			isoRot.speed = 16.666f;
		}
		else
		{
			reasonFire.Stop();	
			reasonFire.audio.Stop();
			reasonBurst.Stop();	
			weaponTrigger.collider.enabled = false;
			isoRot.speed = 0.666f;
		}
	}
	
	// -[Moving platforms]- to inherit platform motion, parent player under platform hierarchy while in contact with it
	void OnCollisionEnter(Collision other)
	{
		if(other.gameObject.tag == "MovingPlatform")
		{
			transform.parent = other.transform;	
		}
	}	
	
	void OnCollisionExit(Collision other)
	{
		if(other.gameObject.tag == "MovingPlatform")
		{
			transform.parent = null;	
		}
	}	
}
