using UnityEngine;
using System.Collections;

public class ReasonTriggerController : MonoBehaviour 
{
	private Manager manager;
	private Collider otherReason;
	
	void OnTriggerEnter(Collider other)
	{
		if(other.gameObject.tag == "Reason")
		{
			otherReason = other;
			manager.DiscoveredReason();
		}
	}
	
	// Use this for initialization
	void Start () 
	{
		manager = GameObject.Find("_MANAGER").GetComponent<Manager>();
	}
	
	// Update is called once per frame
	void Update () 
	{
		if(otherReason != null)
		{
			if(otherReason.transform.localScale.x > 0.0f)
			{
				otherReason.transform.localScale *= 0.95f;	
			}
			else
			{
				Destroy(otherReason.gameObject);	
			}
		}
	}
}
