using UnityEngine;
using System.Collections;

public class TentacleLaserController : MonoBehaviour 
{
	private float shootDelay = 4.0f;
	private float shootTimer = 0.0f;
	
	private float fireLength = 1.0f;
	private float fireTimer = 1.0f;
	
	private LineRenderer lineRenderer;
	private ParticleSystem hitBurst;
	
	// Use this for initialization
	void Start () 
	{
		lineRenderer = GetComponent<LineRenderer>();
		hitBurst = transform.FindChild("HitBurst").GetComponent<ParticleSystem>();
		hitBurst.transform.parent = null;
	}
	
	// Update is called once per frame
	void Update () 
	{
		shootTimer += Time.deltaTime;
		fireTimer += Time.deltaTime;
		

		if(shootTimer > shootDelay)
		{
			shootDelay = Random.Range(2.0f, 6.0f);
			shootTimer = 0.0f;
			fireTimer = 0.0f;
		}
		
		if(fireTimer < fireLength)
		{
			lineRenderer.SetPosition(0, transform.position);	
			lineRenderer.SetPosition(1, transform.position);	
			lineRenderer.SetWidth(0.0f, 0.0f);
			// raycast forward, display beam	
			RaycastHit hit = new RaycastHit();
			if (Physics.Raycast(transform.position, transform.forward, out hit))
			{
				//print (hit.collider.gameObject.name);
				lineRenderer.SetPosition(1, hit.point);
				hitBurst.audio.Play();
				hitBurst.Play();
				hitBurst.transform.localPosition = Vector3.zero;// hit.point;
				hitBurst.transform.Translate(hit.point, Space.World);
				lineRenderer.SetWidth(Mathf.Abs(Mathf.Sin(Time.time*20.0f))*10.0f, Mathf.Abs(Mathf.Sin(Time.time*20.0f))*30.0f);
						
				//PlayerController hitPlayer = hit.collider.gameObject.GetComponent<PlayerController>();
				//if(hitPlayer != null)
				//{
				//	hitPlayer.primaryWeaponDamage += hitPlayer.primaryWeaponDamageRate * Time.deltaTime;	
				//}	
			}
		}
		else
		{
			hitBurst.audio.Stop();
			hitBurst.Stop();
			lineRenderer.SetPosition(0, transform.position);	
			lineRenderer.SetPosition(1, transform.position);	
		}
	}
}
